<?php
// $Id: location.inc,v 1.3 2009/10/28 01:08:30 alexb Exp $

/**
 * @file
 * On behalf implementation of Feeds mapping API for location.module (CCK).
 */

/**
* The below functions allow lat and lon to go into location_cck - they are uncommented here
* and the related lines in customxml_parser.inc.  If you DON'T want to use location_cck
* or don't have lat/lon data - just comment out these functions and the code (lines 84/85)
* in customxml_parser.inc .
*/
function location_feeds_node_processor_targets_alter(&$targets, $content_type) {
  $info = content_types($content_type);
  $fields = array();
  if (isset($info['fields']) && count($info['fields'])) {
    foreach ($info['fields'] as $field_name => $field) {

      if (in_array($field['type'], array('location'))) {
        $name = isset($field['widget']['label']) ? $field['widget']['label'] : $field_name;
        $targets[$field_name .':street'] = array(
          'name' => t('!field_name (street)', array('!field_name' => $name)),
          'callback' => 'location_feeds_set_target',
          'description' => t('The address for the CCK !name field of the node.', array('!name' => $name)),
        );
		$targets[$field_name .':city'] = array(
          'name' => t('!field_name (city)', array('!field_name' => $name)),
          'callback' => 'location_feeds_set_target',
          'description' => t('The address for the CCK !name field of the node.', array('!name' => $name)),
        );
		$targets[$field_name .':province'] = array(
          'name' => t('!field_name (state)', array('!field_name' => $name)),
          'callback' => 'location_feeds_set_target',
          'description' => t('The address for the CCK !name field of the node.', array('!name' => $name)),
        );
		$targets[$field_name .':postal_code'] = array(
          'name' => t('!field_name (zip)', array('!field_name' => $name)),
          'callback' => 'location_feeds_set_target',
          'description' => t('The address for the CCK !name field of the node.', array('!name' => $name)),
        );
      }
    }
  }
} // function location_feeds_node_processor_targets_alter

/**
 * Callback for mapping. Here is where the actual mapping happens.
 *
 * When the callback is invoked, $target contains the name of the field the
 * user has decided to map to and $value contains the value of the feed item
 * element the user has picked as a source.
 */

function location_feeds_set_target($node, $target, $value) {
  list($field_name, $sub_field) = split(':', $target);
  
  if (is_array($value)) {
     foreach ($value as $i => $val) {
       $node->{$field_name}[$i][$sub_field] = $val;
     }
  } else {
    $node->{$field_name}[0][$sub_field] = $value;
  }
   return $node;
} //function location_feeds_set_target